<template>
  <div class="loading" v-if="loading">
    <div class="map-lp lp"></div>
    <List />
  </div>
  <div v-else class="page-map" :class="themeClasses">
    <div class="building-nav-container">
      <div ref="nav" class="building-nav">
        <div
          class="building-nav-item"
          :class="{ 'is-selected': currentBuildingIndex === index }"
          v-for="(b, index) in buildings"
          @click="() => selectBuilding(index)"
        >
          {{ b.name }}
        </div>
      </div>
    </div>

    <div class="building-list-container">
      <building-background :group-id="group.id" />
      <div class="buildings" ref="buildingList" @scroll="onScroll">
        <div class="building-space" />
        <div
          v-for="(b, index) in buildings"
          :key="b.name"
          :ref="'building-' + index"
          class="building-item"
        >
          <building
            :building="b"
            :restaurants="buildingToRestaurants[b.id] || []"
          />
        </div>
        <div class="building-space" />
      </div>
      <div class="building-overlay"></div>
    </div>
    <div ref="restaurantList" class="container m-container-no-gutter">
      <div class="building-desc">
        {{ $t("building.restaurantList", { buildingName: building.name }) }}
      </div>
      <div v-for="fr in floorAndRestaurants">
        <div class="floor-desc flex">
          <div class="floor-desc__name">{{ fr.floor | floorName }}</div>
          <div class="floor-desc__restaurants-count">
            {{
              $t("building.restaurantsCount", { count: fr.restaurants.length })
            }}
          </div>
        </div>
        <div class="restaurant-list">
          <restaurant-item
            v-for="r in fr.restaurants"
            list-type="floor plan list"
            strategy="waiting"
            :key="r.id"
            :restaurant="r"
          />
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import { mapState, mapGetters } from "vuex";
import _ from "underscore";
import Building from "@/components/Group/Building";
import List from "@/components/Group/List";
import BuildingBackground from "@/components/Group/BuildingBackground";
import RestaurantItem from "@/components/Group/RestaurantItem";
import buildingStructure from "@/const/building-structure";

export default {
  components: {
    Building,
    BuildingBackground,
    RestaurantItem,
    List
  },
  props: {
    group: {
      type: Object
    },
    restaurants: {
      type: Array
    }
  },
  data() {
    return {
      currentBuildingIndex: 0,
      progress: 0
    };
  },
  computed: {
    ...mapState("group", ["loading"]),
    ...mapGetters("theme", ["themeClasses"]),
    buildings() {
      return buildingStructure[this.group.id] || _.values(buildingStructure)[0];
    },
    building() {
      return this.buildings[this.currentBuildingIndex];
    },
    visibleRestaurants() {
      const building = this.buildings[this.currentBuildingIndex];
      return this.buildingToRestaurants[building.id];
    },
    buildingToRestaurants() {
      return _.groupBy(this.restaurants, "buildingId");
    },
    floorAndRestaurants() {
      const floorAndRestaurants = Object.entries(
        _.groupBy(this.visibleRestaurants, "floor")
      ).map(([floor, restaurants]) => ({ floor: Number(floor), restaurants }));
      return _.sortBy(floorAndRestaurants, "floor").reverse();
    }
  },
  methods: {
    selectBuilding(index) {
      this.currentBuildingIndex = index;
      const box = this.$refs.buildingList;
      const elem = this.$refs[`building-${index}`][0];
      box.scrollTo({
        top: 0,
        left:
          elem.offsetLeft -
          Math.floor((window.innerWidth - elem.offsetWidth) / 2),
        behavior: "smooth"
      });
    },
    updateBoxSize() {
      const building = document.querySelector(".building-item");
      if (!building) return false;
      const padding = Math.floor(
        (window.innerWidth - building.offsetWidth) / 2
      );
      const elems = document.querySelectorAll(".building-space");
      if (elems.length === 0) return false;
      for (const elem of elems) {
        elem.style.width = `${padding}px`;
      }

      const buildingList = document.querySelector(".buildings");
      const container = document.querySelector(".building-list-container");
      if (!container || !buildingList) return false;
      container.style.height = `${buildingList.offsetHeight - 30}px`;
      return true;
    },
    onScroll() {
      if (this.$refs.buildingList) {
        if (this.scrollTimer) {
          clearTimeout(this.scrollTimer);
        }

        this.scrollTimer = setTimeout(() => {
          this.scrollTimer = null;
          const box = this.$refs.buildingList;
          let max = null;
          let min = null;
          let selectedBuilding = null;
          const scrollPos = box.scrollLeft;
          for (let i = 0; i < this.buildings.length; ++i) {
            const elem = this.$refs[`building-${i}`][0];
            const elemPos =
              elem.offsetLeft -
              Math.floor((window.innerWidth - elem.offsetWidth) / 2);
            min = min === null ? { pos: elemPos, index: i } : min;
            max = { pos: elemPos, index: i };
            if (scrollPos > elemPos - 15 && scrollPos < elemPos + 15) {
              selectedBuilding = i;
            }
          }
          if (!selectedBuilding) {
            if (scrollPos < min.pos) selectedBuilding = min.name;
            if (scrollPos > max.pos) selectedBuilding = max.name;
            this.selectBuilding(selectedBuilding);
          } else if (selectedBuilding !== this.currentBuildingIndex) {
            this.selectBuilding(selectedBuilding);
          }
        }, 100);
      }
    }
  },
  updated() {
    this.updateBoxSize();
  },
  mounted() {
    window.addEventListener("resize", this.updateBoxSize);
    this.updateBoxSize();
  },
  destroyed() {
    if (this.scrollTimer) {
      clearTimeout(this.scrollTimer);
      this.scrollTimer = null;
    }
    window.removeEventListener("resize", this.updateBoxSize);
  }
};
</script>
<style lang="scss">
.map-lp {
  height: 160px;
  @include media-breakpoint-up(md) {
    height: 320px;
  }
}

.page-map {
  position: relative;
}

.building-nav-list {
}

.buildings {
  overflow-x: scroll;
  overflow-y: hidden;
  -webkit-overflow-scrolling: touch;
  display: flex;
  flex-direction: row;
  position: relative;
  align-items: flex-end;
  scroll-behavior: smooth;
  scroll-snap-type: both mandatory;
}

.building-nav-container {
  width: 100%;
  height: 47px;
  overflow: hidden;
  position: sticky;
  top: 0px;
  z-index: 1000;
}

.building-nav {
  display: flex;
  flex-direction: row;
  justify-content: center;
  border-bottom: 1px solid $color-silver-grey;
  left: 0;
  top: 0;
  width: 100%;
  height: 77px;
  overflow-x: scroll;
  overflow-y: hidden;
  -webkit-overflow-scrolling: touch;

  line-height: 44px;
  background-color: $color-white;
  text-align: left;
}

.building-list-container {
  position: relative;
  width: 100%;
  height: auto;
  overflow: hidden;
}

.building-nav-item {
  font-size: 16px;
  padding: 0 16px;
  height: 77px;
  cursor: pointer;
  transition: all 0.3s;
  min-width: 80px;
  max-width: 180px;
  border-bottom: 33px solid rgba($color-skm-red, 0);
  display: flex;
  flex-direction: row;
  justify-content: center;

  &.is-selected {
    color: $color-skm-red;
    font-weight: 500;
    font-size: 18px;
    border-color: rgba($color-skm-red, 1);
  }
}

.building-space {
  height: 1px;
  display: block;
  flex-shrink: 0;
}

.building-item,
.building-overlay {
  width: 100%;
  max-width: 50vh;
  padding-top: 30px;
  bottom: 0;
  flex-shrink: 0;
  scroll-snap-align: center;
  margin-bottom: 30px;

  @include media-breakpoint-up(md) {
    width: 33.3%;
  }
  @include media-breakpoint-up(lg) {
    width: 25%;
    min-width: 300px;
  }
}
.pseudo-building-item {
  // all widths are half of building-item, cause buidling-bg-inner-wrapper has two times width
  opacity: 0;
  width: 50%;
  @include media-breakpoint-up(md) {
    width: 16.665%;
  }
  @include media-breakpoint-up(lg) {
    width: 12.5%;
  }
}

.building-overlay {
  position: absolute;
  top: 0;
  bottom: 0;
  left: 50%;
  transform: translateX(-50%);
  z-index: 3;
  pointer-events: none;
  margin-bottom: 0px;

  &:before,
  &:after {
    content: "";
    display: block;
    position: absolute;
    top: 0;
    height: 100%;
    background-color: rgba(32, 35, 43, 0.2);
    width: 1000%;
  }
  &:before {
    left: 0;
    transform: translateX(-100%);
  }
  &:after {
    right: 0;
    transform: translateX(100%);
  }
}

.theme-vip-member .building-desc {
  background-color: $color-gold-100;
}

.building-desc {
  padding: $grid-gutter-width $grid-gutter-width/2 $grid-gutter-width/2
    $grid-gutter-width/2;
  background-color: $color-genesis-white;
  font-size: 18px;
  color: $color-primary-grey;

  @include media-breakpoint-up(md) {
    font-size: 28px;
    text-align: center;
    color: $color-primary-black;
    padding: 60px 0 30px 0;
  }
}

.theme-vip-member .floor-desc {
  background-color: $color-gold-100;
}

.floor-desc {
  padding: $grid-gutter-width/2;
  justify-content: space-between;
  align-items: flex-end;
  background-color: $color-genesis-white;

  &__name {
    font-size: 18px;
  }
  &__restaurants-count {
    font-size: 14px;
    color: $color-secondary-black;
  }

  @include media-breakpoint-up(md) {
    padding: 0;
    align-items: center;
    &__name {
      font-size: 28px;
    }
    &__restaurants-count {
      font-size: 16px;
    }
  }
}

.restaurant-list {
  @include media-breakpoint-up(md) {
    padding: 20px 0;
    display: flex;
    flex-flow: row wrap;
    margin-left: -15px;
    margin-right: -15px;
  }
}

// Building decoration
.building-bg {
  position: absolute;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
}

.building-bg-sky {
  flex: 1;
  background: url(/static/images/building/bg-sky.svg) left center/auto 100%
    repeat-x;
}

.building-bg-sky-tc {
  flex: 1;
  background: url(/static/images/building/bg-sky-tc.svg) left center/auto 100%
    repeat-x;
}

.building-bg-sky-nanxi {
  flex: 1;
  background: url(/static/images/building/bg-sky-nanxi.svg) left center/auto
    100% repeat-x;
}

.building-bg-sky-TaipeiTianmu {
  flex: 1;
  background: url(/static/images/building/bg-sky-TaipeiTianmu.svg) left
    center/auto 100% repeat-x;
}

.building-bg-sky-TaipeiStation {
  flex: 1;
  background: url(/static/images/building/bg-sky-TaipeiStation.svg) left
    center/auto 100% repeat-x;
}

.building-bg-sky-KaohsiungSanduo {
  flex: 1;
  background: url(/static/images/building/bg-sky-KaohsiungSanduo.svg) left
    center/auto 100% repeat-x;
}

.building-bg-sky-TainanZhongshan {
  flex: 1;
  background: url(/static/images/building/bg-sky-TainanZhongshan.svg) left
    center/auto 100% repeat-x;
}

.building-bg-sky-KaohsiungZuoying {
  flex: 1;
  background: url(/static/images/building/bg-sky-KaohsiungZuoying.svg) left
    center/auto 100% repeat-x;
}

.building-bg-sky-tainan {
  flex: 1;
  background: url(/static/images/building/bg-sky-tainan.svg) left center/auto
    100% repeat-x;
}

.building-bg-sky-ChiayiChuiyang {
  flex: 1;
  background: url(/static/images/building/bg-sky-tainan.svg) left center/auto
    100% repeat-x;
}

.building-bg-sky-TaoyuanDayou {
  flex: 1;
  background: url(/static/images/building/bg-sky-tainan.svg) left center/auto
    100% repeat-x;
}

.building-bg-sky-TaoyuanStation {
  flex: 1;
  background: url(/static/images/building/bg-sky-tainan.svg) left center/auto
    100% repeat-x;
}

.building-bg-underground {
  background: url(/static/images/building/bg-underground.svg) left center/auto
    100% repeat-x;
}

.building-bg-underground-tc {
  background: url(/static/images/building/bg-underground-tc.svg) left
    center/auto 100% repeat-x;
}

.building-bg-underground-nanxi {
  background: url(/static/images/building/bg-underground-nanxi.svg) left
    center/auto 100% repeat-x;
}

.building-bg-underground-TaipeiTianmu {
  background: url(/static/images/building/bg-underground-TaipeiTianmu.svg) left
    center/auto 100% repeat-x;
}

.building-bg-underground-TaipeiStation {
  background: url(/static/images/building/bg-underground-TaipeiStation.svg) left
    center/auto 100% repeat-x;
}

.building-bg-underground-tainan {
  background: url(/static/images/building/bg-underground-tainan.svg) left
    center/auto 100% repeat-x;
}

.building-bg-underground-KaohsiungSanduo {
  background: url(/static/images/building/bg-underground-tainan.svg) left
    center/auto 100% repeat-x;
}

.building-bg-underground-TainanZhongshan {
  background: url(/static/images/building/bg-underground-tainan.svg) left
    center/auto 100% repeat-x;
}

.building-bg-underground-KaohsiungZuoying {
  background: url(/static/images/building/bg-underground-tainan.svg) left
    center/auto 100% repeat-x;
}

.building-bg-underground-ChiayiChuiyang {
  background: url(/static/images/building/bg-underground-tainan.svg) left
    center/auto 100% repeat-x;
}

.building-bg-underground-TaoyuanDayou {
  background: url(/static/images/building/bg-underground-tainan.svg) left
    center/auto 100% repeat-x;
}

.building-bg-underground-TaoyuanStation {
  background: url(/static/images/building/bg-underground-tainan.svg) left
    center/auto 100% repeat-x;
}

.buidling-bg-inner-wrapper {
  position: absolute;
  left: -50%;
  top: 0;
  width: 200%;
  height: 100%;
  display: flex;
  flex-direction: column;
  overflow: hidden;
  will-change: transform;
}
</style>
